﻿using System;
//using System.Collections.Generic;
//using System.Linq;
//using System.Text;

using Microsoft.Test.FaultInjection;
using System.Diagnostics;

namespace FaultHarness
{
  class Program
  {
    static void Main(string[] args)
    {
      try
      {
        Console.WriteLine("\nBegin TestApi Fault Injection environmnent session\n");

        string appUnderTest = "TwoCardPokerGame.exe";
        string method = "TwoCardPokerGame.Form1.button2_Click(object, System.EventArgs)";
        //string method = "TwoCardPokerLib.Deck.Deal(int)";
        ICondition condition = BuiltInConditions.TriggerEveryOnNthCall(3);
        //ICondition condition = BuiltInConditions.TriggerOnEveryCall;

        IFault fault = BuiltInFaults.ThrowExceptionFault(new ApplicationException("Application exception thrown by Fault Harness!"));
        //IFault f = BuiltInFaults.ReturnValueFault(-1);
        FaultRule rule = new FaultRule(method, condition, fault);

        Console.WriteLine("Application under test = " + appUnderTest);
        Console.WriteLine("Method to trigger injected runtime fault = " + method);
        Console.WriteLine("Condition which will trigger fault = On 3rd call");
        Console.WriteLine("Fault which will be triggered = ApplicationException");

        Console.WriteLine("\nVerifying application under test binaries are in current directory");
        // TODO: actually check this!

        FaultSession session = new FaultSession(rule);
        ProcessStartInfo psi = session.GetProcessStartInfo(appUnderTest);
        
        Console.WriteLine("\nProgrammatically launching application under test");
        Process p = Process.Start(psi);
        p.WaitForExit();
        p.Close();

        Console.WriteLine("\nWriting log files to disk");
        Console.WriteLine("\nEnd TestApi Fault Injection environment session");
        Console.ReadLine();
      }

      catch (Exception ex)
      {
        Console.WriteLine("Fatal: " + ex.Message);
        Console.ReadLine();
      }


    }
  }
} // ns
